////////////////////////////////////////////////////////////////////////////////
//
// Handy LK --------------------------------------------------------------------
//
// File: ceresexport.h
// Copyright 2005-2006 by Hendrik Spohr, Vienna, AUSTRIA
//
////////////////////////////////////////////////////////////////////////////////
#ifndef _CERESEXPORT_H_
#define _CERESEXPORT_H_

#include "export/exportxml.h"

namespace HLK
{
  class Document;
  class UsedDefinitionsList;
}

namespace ProofLib
{
  class ProofDatabase;
  class Proof;
}

class ExportCeres : public ExportXML
{
protected:
  ExportCeres();

public:
  static ExportCeres* New();

public:
  virtual void Write( const ProofLib::ProofDatabase* proofdb ) = 0;
  virtual void Write( const ProofLib::Proof* proof,
                      const ProofLib::ProofDatabase* proofdb ) = 0;
  virtual void Write( const ProofLib::ProofDatabase* proofdb,
                      const HLK::UsedDefinitionsList *defs,
                      const HLK::Document* doc ) = 0;

  virtual void Open( const char *sourcename ) = 0;
  virtual void Close() = 0;
};

#endif
