////////////////////////////////////////////////////////////////////////////////
//
// Handy LK --------------------------------------------------------------------
//
// File: compilehlk.h
// Copyright 2005-2006 by Hendrik Spohr, Vienna, AUSTRIA
//
////////////////////////////////////////////////////////////////////////////////
#ifndef _COMPILEHLK_H_
#define _COMPILEHLK_H_

namespace ProofLib
{
  class ProofDatabase;
}

namespace HLK
{

class Document;
class ProofSymbol;

class UsedDefinitionsList
{
public:
  virtual size_t GetCount() const = 0;
  virtual const ProofLib::Symbol* GetSymbol( size_t index ) const = 0;
  virtual std::set<size_t> GetRecursionLevels( size_t index ) const = 0;
};

class Compiler
{
protected:
  Compiler() {}
  Compiler( const Compiler& ) {}

public:
  virtual ~Compiler() {}

  static bool simulate_pred_undefs;

  static Compiler *NewCompiler();

  virtual ProofLib::ProofDatabase* GenerateLK( const Document *doc,
                                               const ProofSymbol *ps ) = 0;
  virtual ProofLib::ProofDatabase* GenerateLK( const Document *doc,
                                               const USTRING &proof ) = 0;

  virtual const UsedDefinitionsList* GetUsedDefinitionsList() const = 0;
};

}

#endif
