////////////////////////////////////////////////////////////////////////////////
//
// Handy LK --------------------------------------------------------------------
//
// File: printhlk.h
// Copyright 2005-2006 by Hendrik Spohr, Vienna, AUSTRIA
//
////////////////////////////////////////////////////////////////////////////////
#ifndef _PRINTHLK_H_
#define _PRINTHLK_H_

#include <iostream>

namespace ProofLib
{
  class Term;
  class Formula;
  class FormulaList;
  class Sequent;
  class VariableSubstitution;
  class NodePointer;
  class RecursiveExpr;
  class SourceLocation;
}

namespace HLK
{

class Print
{
public:
  static bool use_utf8;

public:
  static void PrintTerm( const ProofLib::Term *t, std::ostream &out,
                         bool need_prnth = false );
  static void PrintTerm( const ProofLib::Term *t, std::wostream &out,
                         bool need_prnth = false );
  static void PrintFormula( const ProofLib::Formula *f, std::ostream &out,
                            bool need_prnth = false );
  static void PrintFormulaList( const ProofLib::FormulaList *l,
                                std::ostream &out );
  static void PrintSequent( const ProofLib::Sequent *s, std::ostream &out );
  static void PrintSequentAsList( const ProofLib::Sequent *s,
                                  std::ostream &out );
  static void PrintVariableSubstitution(
    const ProofLib::VariableSubstitution *u,
    std::ostream &out );
  static void PrintNodePointer( const ProofLib::NodePointer *np,
                                std::ostream &out );
  static void PrintRecursiveExpr( const ProofLib::RecursiveExpr *expr,
                                  std::ostream &out );
  static void PrintRecursiveExpr( const ProofLib::RecursiveExpr *expr,
                                  std::wostream &out );

  static void PrintSLoc( const ProofLib::SourceLocation &sloc,
                         std::ostream &out );
};

}

#endif

