////////////////////////////////////////////////////////////////////////////////
//
// Handy LK --------------------------------------------------------------------
//
// File: typehlk.h
// Copyright 2005-2006 by Hendrik Spohr, Vienna, AUSTRIA
//
////////////////////////////////////////////////////////////////////////////////
#ifndef _TYPEHLK_H_
#define _TYPEHLK_H_

namespace ProofLib
{
  class NodeDatabase;
  class Sequent;
}

namespace HLK
{

class SymbolTable;
class ProofTable;

class AxiomTable
{
public:
  virtual ~AxiomTable() {}

public:
  virtual void AddAxiom( ProofLib::Sequent *seq,
                         const wchar_t *name = NULL ) = 0;
  virtual size_t GetCount() const = 0;
  virtual ProofLib::Sequent* GetAxiomAt( size_t index ) const = 0;
  virtual const char* GetNameAt( size_t index ) const = 0;
  virtual ProofLib::Sequent* GetAxiom( const wchar_t *name ) = 0;
};

class Document
{
  SymbolTable                *m_symbol_table;
  ProofLib::NodeDatabase     *m_node_database;
  AxiomTable                 *m_axiom_table;
  ProofTable                 *m_proof_table;

public:
  Document();
  ~Document();

  SymbolTable* GetSymbolTable() const;
  ProofTable* GetProofTable() const;
  AxiomTable* GetAxiomTable() const;
  ProofLib::NodeDatabase* GetNodeDatabase() const { return m_node_database; }
};

}

#endif
