#!/bin/bash

HLK=src/hlk

if test -z "$1"
then
  echo "Usage: $0 <input-file>"
  exit 1
fi

FILE=$1

PROOFS=$( cat $FILE | grep "^define proof" | sed -e "s/^define proof *//" )

time for i in $PROOFS
do
  echo $i
  $HLK -o /dev/null $FILE $i

  RESULT=$?

  if test ${i:0:3} = "bad"
  then
    if test $RESULT -eq 1
    then
      echo "--GOOD (PROOF HAS EXCEPTED ERRORS)--"
    else
      echo "STOP $i SHOULD FAIL!"
      exit 1
    fi
  else
    if test $RESULT -eq 0
    then
      echo "--GOOD--"
    else
      echo "STOP BY ERROR in $i"
      exit 1
    fi
  fi
done

exit 0

